<?
/** 
*
* @package phpBB3
* @version $Id: update_bbcode.php,v 1.0 2007/08/04 ycl6 Exp $
* @copyright ycl6 < ycl6@users.sourceforge.net > (Y.C. LIN) http://macphpbbmod.sourceforge.net/
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

set_time_limit(0);

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_INSTALL', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/simple_hide_bbcode');

// Is user any type of admin? No, then stop here, each script needs to
// check specific permissions but this is a catchall
if (!$auth->acl_get('a_'))
{
	trigger_error('NO_ADMIN');
}

// Pulls database post data
$post_data = array();

$sql = 'SELECT post_id, post_text, bbcode_uid, bbcode_bitfield, enable_bbcode, enable_magic_url, enable_smilies
		FROM ' . POSTS_TABLE;

$result = $db->sql_query($sql);

$post_data = array();
while ($row = $db->sql_fetchrow($result))
{
	$post_data[] = $row;
}
$db->sql_freeresult($result);

// Start processing post content here
foreach ($post_data as $post)
{
	if (preg_match("/\[hide\]/i", $post['post_text']))
	{
		$flags = '';
		$message = censor_text($post['post_text']);
		decode_message($message, $post['bbcode_uid']);

		// function generate_text_for_storage(&$text, &$uid, &$bitfield, &$flags, $allow_bbcode = false, $allow_urls = false, $allow_smilies = false)
		generate_text_for_storage($message, $post['bbcode_uid'], $post['bbcode_bitfield'], $flags, $post['enable_bbcode'], $post['enable_magic_url'], $post['enable_smilies']);

		$sql_data[POSTS_TABLE]['sql'] = array(
			'post_id'				=> (int) $post['post_id'],
			'bbcode_bitfield'		=> $post['bbcode_bitfield'],
			'bbcode_uid'			=> $post['bbcode_uid'],
			'post_text'				=> $message,
		);

		// Update the posts table
		if (isset($sql_data[POSTS_TABLE]['sql']))
		{
			$sql = 'UPDATE ' . POSTS_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_data[POSTS_TABLE]['sql']) . '
				WHERE post_id = ' . $post['post_id'];
			$db->sql_query($sql);
		}
		unset($sql_data[POSTS_TABLE]['sql']);
	}
}

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="en-gb" xml:lang="en-gb">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<meta http-equiv="Content-Language" content="en-gb" />
<meta http-equiv="imagetoolbar" content="no" />
<title>' . $user->lang['CONVERT_TITLE'] . '</title>
<link href="' . $phpbb_root_path . '/adm/style/admin.css" rel="stylesheet" type="text/css" media="screen" />

</head>

<body class="ltr">
<div id="wrap">
	<div id="acp">
		<div id="panel">
			<span class="corners-top"><span></span></span>
			<div id="content">
				<div id="menu"></div>
				<div id="main"><span>' . $user->lang['CONVERT_DONE'] . '</span></div>
			</div>
			<span class="corners-bottom"><span></span></span>
		</div>
	</div>
</div>
</body>
</html>';

?>